#!/usr/bin/env python
""" Copyright (c) 2020, Institute of Automatic Control - RWTH Aachen University
   All rights reserved. """

import geometry_msgs.msg as gm
import yaml
import numpy as np
import rospy
import tf.transformations as tf_tools
import tf2_ros


def publish_static_tf(filename, frame_id, child_frame_id):
    '''
    Publish a static transform from a .yml file which contains a 4x4
    transformation matrix. Intended for publishing an initial transform

    Parameters
    ----------
    filename : string
        the path to the .yml file
    '''
    with open(filename, "r") as file:
        # parse yaml
        firstline = file.readline()
        if firstline.startswith("%YAML:1.0"):
            # skip first two lines if generated by opencv
            file.readline()
        else:
            file.seek(0)
        document = yaml.load(file)
        tf_matrix = document["tf_matrix"]
        tf_matrix = np.array(tf_matrix)
        tf_matrix = np.reshape(tf_matrix, (4, 4))
        # convert to geometry_msgs.TransformStamped
        tf_msg = gm.TransformStamped()
        tf_msg.header.stamp = rospy.Time.now()
        tf_msg.header.frame_id = frame_id
        tf_msg.child_frame_id = child_frame_id
        quat = tf_tools.quaternion_from_matrix(tf_matrix)
        tf_msg.transform.rotation.x = quat[0]
        tf_msg.transform.rotation.y = quat[1]
        tf_msg.transform.rotation.z = quat[2]
        tf_msg.transform.rotation.w = quat[3]
        trans = tf_tools.translation_from_matrix(tf_matrix)
        tf_msg.transform.translation.x = trans[0]
        tf_msg.transform.translation.y = trans[1]
        tf_msg.transform.translation.z = trans[2]
        rospy.loginfo(tf_matrix)
        # broadcast the transform
        broadcaster = tf2_ros.StaticTransformBroadcaster()
        broadcaster.sendTransform(tf_msg)
        rospy.spin()


if __name__ == '__main__':
    try:
        rospy.init_node('static_tf_yml', anonymous=True)
        filename = rospy.get_param("~filename")
        frame_id = rospy.get_param("~frame_id", "aruco_0")
        child_frame_id = rospy.get_param("~child_frame_id", "initial_pose")
        publish_static_tf(filename, frame_id, child_frame_id)
    except rospy.ROSInterruptException:
        pass
